# Copyright 2015 Cisco Systems, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""
This is a auto-generated helper module for bios token configuration

"""


bios_tokens_table = {
    "modular": {
        "ASPMSupport": {"mo_name": "BiosVfASPMSupport", "prop_name": "vp_aspm_support"},
        "AdjacentCacheLinePrefetch": {"mo_name": "BiosVfAdjacentCacheLinePrefetch", "prop_name": "vp_adjacent_cache_line_prefetch"},
        "Altitude": {"mo_name": "BiosVfAltitude", "prop_name": "vp_altitude"},
        "AssertNMIOnPERR": {"mo_name": "BiosVfAssertNMIOnPERR", "prop_name": "vp_assert_nmi_on_perr"},
        "AssertNMIOnSERR": {"mo_name": "BiosVfAssertNMIOnSERR", "prop_name": "vp_assert_nmi_on_serr"},
        "AutonumousCstateEnable": {"mo_name": "BiosVfAutonumousCstateEnable", "prop_name": "vp_autonumous_cstate_enable"},
        "BootOptionRetry": {"mo_name": "BiosVfBootOptionRetry", "prop_name": "vp_boot_option_retry"},
        "BootPerformanceMode": {"mo_name": "BiosVfBootPerformanceMode", "prop_name": "vp_boot_performance_mode"},
        "CDNEnable": {"mo_name": "BiosVfCDNEnable", "prop_name": "vp_cdn_enable"},
        "CDNSupport": {"mo_name": "BiosVfCDNSupport", "prop_name": "vp_cdn_support"},
        "CPUEnergyPerformance": {"mo_name": "BiosVfCPUEnergyPerformance", "prop_name": "vp_cpu_energy_performance"},
        "CPUFrequencyFloor": {"mo_name": "BiosVfCPUFrequencyFloor", "prop_name": "vp_cpu_frequency_floor"},
        "CPUPerformance": {"mo_name": "BiosVfCPUPerformance", "prop_name": "vp_cpu_performance"},
        "CPUPowerManagement": {"mo_name": "BiosVfCPUPowerManagement", "prop_name": "vp_cpu_power_management"},
        "CkeLowPolicy": {"mo_name": "BiosVfCkeLowPolicy", "prop_name": "vp_cke_low_policy"},
        "CmciEnable": {"mo_name": "BiosVfCmciEnable", "prop_name": "vp_cmci_enable"},
        "BaudRate": {"mo_name": "BiosVfConsoleRedirection", "prop_name": "vp_baud_rate"},
        "ConsoleRedirection": {"mo_name": "BiosVfConsoleRedirection", "prop_name": "vp_console_redirection"},
        "FlowControl": {"mo_name": "BiosVfConsoleRedirection", "prop_name": "vp_flow_control"},
        "PuttyKeyPad": {"mo_name": "BiosVfConsoleRedirection", "prop_name": "vp_putty_key_pad"},
        "RedirectionAfterPOST": {"mo_name": "BiosVfConsoleRedirection", "prop_name": "vp_redirection_after_post"},
        "TerminalType": {"mo_name": "BiosVfConsoleRedirection", "prop_name": "vp_terminal_type"},
        "CoreMultiProcessing": {"mo_name": "BiosVfCoreMultiProcessing", "prop_name": "vp_core_multi_processing"},
        "IPPrefetch": {"mo_name": "BiosVfDCUPrefetch", "prop_name": "vp_ip_prefetch"},
        "StreamerPrefetch": {"mo_name": "BiosVfDCUPrefetch", "prop_name": "vp_streamer_prefetch"},
        "DRAMClockThrottling": {"mo_name": "BiosVfDRAMClockThrottling", "prop_name": "vp_dram_clock_throttling"},
        "DemandScrub": {"mo_name": "BiosVfDemandScrub", "prop_name": "vp_demand_scrub"},
        "DirectCacheAccess": {"mo_name": "BiosVfDirectCacheAccess", "prop_name": "vp_direct_cache_access"},
        "DramRefreshRate": {"mo_name": "BiosVfDramRefreshRate", "prop_name": "vp_dram_refresh_rate"},
        "EnhancedIntelSpeedStepTech": {"mo_name": "BiosVfEnhancedIntelSpeedStepTech", "prop_name": "vp_enhanced_intel_speed_step_tech"},
        "ExecuteDisableBit": {"mo_name": "BiosVfExecuteDisableBit", "prop_name": "vp_execute_disable_bit"},
        "ExtendedAPIC": {"mo_name": "BiosVfExtendedAPIC", "prop_name": "vp_extended_apic"},
        "FRB2Enable": {"mo_name": "BiosVfFRB2Enable", "prop_name": "vp_fr_b2_enable"},
        "HWPMEnable": {"mo_name": "BiosVfHWPMEnable", "prop_name": "vp_hwpm_enable"},
        "HardwarePrefetch": {"mo_name": "BiosVfHardwarePrefetch", "prop_name": "vp_hardware_prefetch"},
        "IOHResource": {"mo_name": "BiosVfIOHResource", "prop_name": "vp_ioh_resource"},
        "IntelHyperThreadingTech": {"mo_name": "BiosVfIntelHyperThreadingTech", "prop_name": "vp_intel_hyper_threading_tech"},
        "IntelTurboBoostTech": {"mo_name": "BiosVfIntelTurboBoostTech", "prop_name": "vp_intel_turbo_boost_tech"},
        "IntelVTDATSSupport": {"mo_name": "BiosVfIntelVTForDirectedIO", "prop_name": "vp_intel_vtdats_support"},
        "IntelVTDCoherencySupport": {"mo_name": "BiosVfIntelVTForDirectedIO", "prop_name": "vp_intel_vtd_coherency_support"},
        "IntelVTDInterruptRemapping": {"mo_name": "BiosVfIntelVTForDirectedIO", "prop_name": "vp_intel_vtd_interrupt_remapping"},
        "IntelVTDPassThroughDMASupport": {"mo_name": "BiosVfIntelVTForDirectedIO", "prop_name": "vp_intel_vtd_pass_through_dma_support"},
        "IntelVTForDirectedIO": {"mo_name": "BiosVfIntelVTForDirectedIO", "prop_name": "vp_intel_vt_for_directed_io"},
        "IntelVirtualizationTechnology": {"mo_name": "BiosVfIntelVirtualizationTechnology", "prop_name": "vp_intel_virtualization_technology"},
        "LOMPort0State": {"mo_name": "BiosVfLOMPortOptionROM", "prop_name": "vp_lom_port0_state"},
        "LOMPort1State": {"mo_name": "BiosVfLOMPortOptionROM", "prop_name": "vp_lom_port1_state"},
        "LOMPort2State": {"mo_name": "BiosVfLOMPortOptionROM", "prop_name": "vp_lom_port2_state"},
        "LOMPort3State": {"mo_name": "BiosVfLOMPortOptionROM", "prop_name": "vp_lom_port3_state"},
        "LOMPortsAllState": {"mo_name": "BiosVfLOMPortOptionROM", "prop_name": "vp_lom_ports_all_state"},
        "LegacyUSBSupport": {"mo_name": "BiosVfLegacyUSBSupport", "prop_name": "vp_legacy_usb_support"},
        "LvDDRMode": {"mo_name": "BiosVfLvDIMMSupport", "prop_name": "vp_lv_ddr_mode"},
        "MMCFGBase": {"mo_name": "BiosVfMMCFGBase", "prop_name": "vp_mmcfg_base"},
        "ChannelInterLeave": {"mo_name": "BiosVfMemoryInterleave", "prop_name": "vp_channel_inter_leave"},
        "MemoryInterLeave": {"mo_name": "BiosVfMemoryInterleave", "prop_name": "vp_memory_inter_leave"},
        "RankInterLeave": {"mo_name": "BiosVfMemoryInterleave", "prop_name": "vp_rank_inter_leave"},
        "MemoryMappedIOAbove4GB": {"mo_name": "BiosVfMemoryMappedIOAbove4GB", "prop_name": "vp_memory_mapped_io_above4_gb"},
        "MirroringMode": {"mo_name": "BiosVfMirroringMode", "prop_name": "vp_mirroring_mode"},
        "NUMAOptimized": {"mo_name": "BiosVfNUMAOptimized", "prop_name": "vp_numa_optimized"},
        "OSBootWatchdogTimer": {"mo_name": "BiosVfOSBootWatchdogTimer", "prop_name": "vp_os_boot_watchdog_timer"},
        "OSBootWatchdogTimerPolicy": {"mo_name": "BiosVfOSBootWatchdogTimerPolicy", "prop_name": "vp_os_boot_watchdog_timer_policy"},
        "OSBootWatchdogTimerTimeout": {"mo_name": "BiosVfOSBootWatchdogTimerTimeout", "prop_name": "vp_os_boot_watchdog_timer_timeout"},
        "Onboard10GbitLOM": {"mo_name": "BiosVfOnboardNIC", "prop_name": "vp_onboard10_gbit_lom"},
        "OnboardGbitLOM": {"mo_name": "BiosVfOnboardNIC", "prop_name": "vp_onboard_gbit_lom"},
        "OnboardSCUStorageSupport": {"mo_name": "BiosVfOnboardStorage", "prop_name": "vp_onboard_scu_storage_support"},
        "OnboardSCUStorageSWStack": {"mo_name": "BiosVfOnboardStorageSWStack", "prop_name": "vp_onboard_scu_storage_sw_stack"},
        "OutOfBandMgmtPort": {"mo_name": "BiosVfOutOfBandMgmtPort", "prop_name": "vp_out_of_band_mgmt_port"},
        "PCIOptionROMs": {"mo_name": "BiosVfPCIOptionROMs", "prop_name": "vp_pci_option_ro_ms"},
        "IOESlot1State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_ioe_slot1_state"},
        "IOESlot2State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_ioe_slot2_state"},
        "Slot10LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot10_link_speed"},
        "Slot10State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot10_state"},
        "Slot1LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot1_link_speed"},
        "Slot1State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot1_state"},
        "Slot2LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot2_link_speed"},
        "Slot2State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot2_state"},
        "Slot3LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot3_link_speed"},
        "Slot3State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot3_state"},
        "Slot4LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot4_link_speed"},
        "Slot4State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot4_state"},
        "Slot5LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot5_link_speed"},
        "Slot5State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot5_state"},
        "Slot6LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot6_link_speed"},
        "Slot6State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot6_state"},
        "Slot7LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot7_link_speed"},
        "Slot7State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot7_state"},
        "Slot8LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot8_link_speed"},
        "Slot8State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot8_state"},
        "Slot9LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot9_link_speed"},
        "Slot9State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot9_state"},
        "SlotHBAState": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_hba_state"},
        "SlotIOEMezz1LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_ioe_mezz1_link_speed"},
        "SlotIOEMezz1State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_ioe_mezz1_state"},
        "SlotIOENVMe1LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_ioenv_me1_link_speed"},
        "SlotIOENVMe1State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_ioenv_me1_state"},
        "SlotIOENVMe2LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_ioenv_me2_link_speed"},
        "SlotIOENVMe2State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_ioenv_me2_state"},
        "SlotIOESlot1LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_ioe_slot1_link_speed"},
        "SlotIOESlot2LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_ioe_slot2_link_speed"},
        "SlotMLOMState": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_mlom_state"},
        "SlotMLinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_m_link_speed"},
        "SlotMezzState": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_mezz_state"},
        "SlotN1State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_n1_state"},
        "SlotN2State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_n2_state"},
        "SlotSASState": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_sas_state"},
        "SlotSBMezz1LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_sb_mezz1_link_speed"},
        "SlotSBMezz1State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_sb_mezz1_state"},
        "SlotSBMezz2LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_sb_mezz2_link_speed"},
        "SlotSBMezz2State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_sb_mezz2_state"},
        "SlotSBNVMe1LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_sbnv_me1_link_speed"},
        "SlotSBNVMe1State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_sbnv_me1_state"},
        "SlotSIOC1LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_sio_c1_link_speed"},
        "SlotSIOC1State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_sio_c1_state"},
        "SlotSIOC2LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_sio_c2_link_speed"},
        "SlotSIOC2State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_sio_c2_state"},
        "POSTErrorPause": {"mo_name": "BiosVfPOSTErrorPause", "prop_name": "vp_post_error_pause"},
        "PStateCoordType": {"mo_name": "BiosVfPStateCoordType", "prop_name": "vp_p_state_coord_type"},
        "PackageCStateLimit": {"mo_name": "BiosVfPackageCStateLimit", "prop_name": "vp_package_c_state_limit"},
        "PatrolScrub": {"mo_name": "BiosVfPatrolScrub", "prop_name": "vp_patrol_scrub"},
        "PatrolScrubDuration": {"mo_name": "BiosVfPatrolScrubDuration", "prop_name": "vp_patrol_scrub_duration"},
        "PchUsb30Mode": {"mo_name": "BiosVfPchUsb30Mode", "prop_name": "vp_pch_usb30_mode"},
        "PciRomClp": {"mo_name": "BiosVfPciRomClp", "prop_name": "vp_pci_rom_clp"},
        "POPSupport": {"mo_name": "BiosVfPowerOnPasswordSupport", "prop_name": "vp_pop_support"},
        "ProcessorC1E": {"mo_name": "BiosVfProcessorC1E", "prop_name": "vp_processor_c1_e"},
        "ProcessorC3Report": {"mo_name": "BiosVfProcessorC3Report", "prop_name": "vp_processor_c3_report"},
        "ProcessorC6Report": {"mo_name": "BiosVfProcessorC6Report", "prop_name": "vp_processor_c6_report"},
        "ProcessorCState": {"mo_name": "BiosVfProcessorCState", "prop_name": "vp_processor_c_state"},
        "PwrPerfTuning": {"mo_name": "BiosVfPwrPerfTuning", "prop_name": "vp_pwr_perf_tuning"},
        "QPILinkFrequency": {"mo_name": "BiosVfQPIConfig", "prop_name": "vp_qpi_link_frequency"},
        "QpiSnoopMode": {"mo_name": "BiosVfQpiSnoopMode", "prop_name": "vp_qpi_snoop_mode"},
        "ResumeOnACPowerLoss": {"mo_name": "BiosVfResumeOnACPowerLoss", "prop_name": "vp_resume_on_ac_power_loss"},
        "SataModeSelect": {"mo_name": "BiosVfSataModeSelect", "prop_name": "vp_sata_mode_select"},
        "SelectMemoryRASConfiguration": {"mo_name": "BiosVfSelectMemoryRASConfiguration", "prop_name": "vp_select_memory_ras_configuration"},
        "SerialPortAEnable": {"mo_name": "BiosVfSerialPortAEnable", "prop_name": "vp_serial_port_a_enable"},
        "SparingMode": {"mo_name": "BiosVfSparingMode", "prop_name": "vp_sparing_mode"},
        "SrIov": {"mo_name": "BiosVfSrIov", "prop_name": "vp_sr_iov"},
        "TPMSupport": {"mo_name": "BiosVfTPMSupport", "prop_name": "vp_tpm_support"},
        "UCSMBootOrderRule": {"mo_name": "BiosVfUCSMBootOrderRuleControl", "prop_name": "vp_ucsm_boot_order_rule"},
        "MakeDeviceNonBootable": {"mo_name": "BiosVfUSBBootConfig", "prop_name": "vp_make_device_non_bootable"},
        "USBEmul6064": {"mo_name": "BiosVfUSBEmulation", "prop_name": "vp_usb_emul6064"},
        "AllUsbDevices": {"mo_name": "BiosVfUSBPortsConfig", "prop_name": "vp_all_usb_devices"},
        "UsbPortFront": {"mo_name": "BiosVfUSBPortsConfig", "prop_name": "vp_usb_port_front"},
        "UsbPortInternal": {"mo_name": "BiosVfUSBPortsConfig", "prop_name": "vp_usb_port_internal"},
        "UsbPortKVM": {"mo_name": "BiosVfUSBPortsConfig", "prop_name": "vp_usb_port_kvm"},
        "UsbPortRear": {"mo_name": "BiosVfUSBPortsConfig", "prop_name": "vp_usb_port_rear"},
        "UsbPortSDCard": {"mo_name": "BiosVfUSBPortsConfig", "prop_name": "vp_usb_port_sd_card"},
        "UsbPortVMedia": {"mo_name": "BiosVfUSBPortsConfig", "prop_name": "vp_usb_port_v_media"},
        "UsbXhciSupport": {"mo_name": "BiosVfUsbXhciSupport", "prop_name": "vp_usb_xhci_support"},
        "VgaPriority": {"mo_name": "BiosVfVgaPriority", "prop_name": "vp_vga_priority"},
        "WorkLoadConfig": {"mo_name": "BiosVfWorkLoadConfig", "prop_name": "vp_work_load_config"},
    },

    "classic": {
        "ASPMSupport": {"mo_name": "BiosVfASPMSupport", "prop_name": "vp_aspm_support"},
        "AdjacentCacheLinePrefetch": {"mo_name": "BiosVfAdjacentCacheLinePrefetch", "prop_name": "vp_adjacent_cache_line_prefetch"},
        "Altitude": {"mo_name": "BiosVfAltitude", "prop_name": "vp_altitude"},
        "AssertNMIOnPERR": {"mo_name": "BiosVfAssertNMIOnPERR", "prop_name": "vp_assert_nmi_on_perr"},
        "AssertNMIOnSERR": {"mo_name": "BiosVfAssertNMIOnSERR", "prop_name": "vp_assert_nmi_on_serr"},
        "AutonumousCstateEnable": {"mo_name": "BiosVfAutonumousCstateEnable", "prop_name": "vp_autonumous_cstate_enable"},
        "BootOptionNumRetry": {"mo_name": "BiosVfBootOptionNumRetry", "prop_name": "vp_boot_option_num_retry"},
        "BootOptionReCoolDown": {"mo_name": "BiosVfBootOptionReCoolDown", "prop_name": "vp_boot_option_re_cool_down"},
        "BootOptionRetry": {"mo_name": "BiosVfBootOptionRetry", "prop_name": "vp_boot_option_retry"},
        "BootPerformanceMode": {"mo_name": "BiosVfBootPerformanceMode", "prop_name": "vp_boot_performance_mode"},
        "CDNEnable": {"mo_name": "BiosVfCDNEnable", "prop_name": "vp_cdn_enable"},
        "CDNSupport": {"mo_name": "BiosVfCDNSupport", "prop_name": "vp_cdn_support"},
        "CPUEnergyPerformance": {"mo_name": "BiosVfCPUEnergyPerformance", "prop_name": "vp_cpu_energy_performance"},
        "CPUFrequencyFloor": {"mo_name": "BiosVfCPUFrequencyFloor", "prop_name": "vp_cpu_frequency_floor"},
        "CPUPerformance": {"mo_name": "BiosVfCPUPerformance", "prop_name": "vp_cpu_performance"},
        "CPUPowerManagement": {"mo_name": "BiosVfCPUPowerManagement", "prop_name": "vp_cpu_power_management"},
        "CkeLowPolicy": {"mo_name": "BiosVfCkeLowPolicy", "prop_name": "vp_cke_low_policy"},
        "ClosedLoopThermThrotl": {"mo_name": "BiosVfClosedLoopThermThrotl", "prop_name": "vp_closed_loop_therm_throtl"},
        "CmciEnable": {"mo_name": "BiosVfCmciEnable", "prop_name": "vp_cmci_enable"},
        "ConfigTDP": {"mo_name": "BiosVfConfigTDP", "prop_name": "vp_config_tdp"},
        "BaudRate": {"mo_name": "BiosVfConsoleRedirection", "prop_name": "vp_baud_rate"},
        "ConsoleRedirection": {"mo_name": "BiosVfConsoleRedirection", "prop_name": "vp_console_redirection"},
        "FlowControl": {"mo_name": "BiosVfConsoleRedirection", "prop_name": "vp_flow_control"},
        "LegacyOSRedirection": {"mo_name": "BiosVfConsoleRedirection", "prop_name": "vp_legacy_os_redirection"},
        "PuttyKeyPad": {"mo_name": "BiosVfConsoleRedirection", "prop_name": "vp_putty_key_pad"},
        "RedirectionAfterPOST": {"mo_name": "BiosVfConsoleRedirection", "prop_name": "vp_redirection_after_post"},
        "TerminalType": {"mo_name": "BiosVfConsoleRedirection", "prop_name": "vp_terminal_type"},
        "CoreMultiProcessing": {"mo_name": "BiosVfCoreMultiProcessing", "prop_name": "vp_core_multi_processing"},
        "IPPrefetch": {"mo_name": "BiosVfDCUPrefetch", "prop_name": "vp_ip_prefetch"},
        "StreamerPrefetch": {"mo_name": "BiosVfDCUPrefetch", "prop_name": "vp_streamer_prefetch"},
        "DRAMClockThrottling": {"mo_name": "BiosVfDRAMClockThrottling", "prop_name": "vp_dram_clock_throttling"},
        "DemandScrub": {"mo_name": "BiosVfDemandScrub", "prop_name": "vp_demand_scrub"},
        "DirectCacheAccess": {"mo_name": "BiosVfDirectCacheAccess", "prop_name": "vp_direct_cache_access"},
        "DramRefreshRate": {"mo_name": "BiosVfDramRefreshRate", "prop_name": "vp_dram_refresh_rate"},
        "EngPerfTuning": {"mo_name": "BiosVfEngPerfTuning", "prop_name": "vp_eng_perf_tuning"},
        "EnhancedIntelSpeedStepTech": {"mo_name": "BiosVfEnhancedIntelSpeedStepTech", "prop_name": "vp_enhanced_intel_speed_step_tech"},
        "ExecuteDisableBit": {"mo_name": "BiosVfExecuteDisableBit", "prop_name": "vp_execute_disable_bit"},
        "ExtendedAPIC": {"mo_name": "BiosVfExtendedAPIC", "prop_name": "vp_extended_apic"},
        "FRB2Enable": {"mo_name": "BiosVfFRB2Enable", "prop_name": "vp_fr_b2_enable"},
        "HWPMEnable": {"mo_name": "BiosVfHWPMEnable", "prop_name": "vp_hwpm_enable"},
        "HardwarePrefetch": {"mo_name": "BiosVfHardwarePrefetch", "prop_name": "vp_hardware_prefetch"},
        "IMCInterleave": {"mo_name": "BiosVfIMCInterleave", "prop_name": "vp_imc_interleave"},
        "IOHResource": {"mo_name": "BiosVfIOHResource", "prop_name": "vp_ioh_resource"},
        "IPV6PXE": {"mo_name": "BiosVfIPV6PXE", "prop_name": "vp_ip_v6_pxe"},
        "IntelHyperThreadingTech": {"mo_name": "BiosVfIntelHyperThreadingTech", "prop_name": "vp_intel_hyper_threading_tech"},
        "IntelTurboBoostTech": {"mo_name": "BiosVfIntelTurboBoostTech", "prop_name": "vp_intel_turbo_boost_tech"},
        "IntelVTDATSSupport": {"mo_name": "BiosVfIntelVTForDirectedIO", "prop_name": "vp_intel_vtdats_support"},
        "IntelVTDCoherencySupport": {"mo_name": "BiosVfIntelVTForDirectedIO", "prop_name": "vp_intel_vtd_coherency_support"},
        "IntelVTDInterruptRemapping": {"mo_name": "BiosVfIntelVTForDirectedIO", "prop_name": "vp_intel_vtd_interrupt_remapping"},
        "IntelVTDPassThroughDMASupport": {"mo_name": "BiosVfIntelVTForDirectedIO", "prop_name": "vp_intel_vtd_pass_through_dma_support"},
        "IntelVTForDirectedIO": {"mo_name": "BiosVfIntelVTForDirectedIO", "prop_name": "vp_intel_vt_for_directed_io"},
        "IntelVirtualizationTechnology": {"mo_name": "BiosVfIntelVirtualizationTechnology", "prop_name": "vp_intel_virtualization_technology"},
        "IohErrorEnable": {"mo_name": "BiosVfIohErrorEn", "prop_name": "vp_ioh_error_enable"},
        "KTIPrefetch": {"mo_name": "BiosVfKTIPrefetch", "prop_name": "vp_kti_prefetch"},
        "LLCPrefetch": {"mo_name": "BiosVfLLCPrefetch", "prop_name": "vp_llc_prefetch"},
        "LOMPort0State": {"mo_name": "BiosVfLOMPortOptionROM", "prop_name": "vp_lom_port0_state"},
        "LOMPort1State": {"mo_name": "BiosVfLOMPortOptionROM", "prop_name": "vp_lom_port1_state"},
        "LOMPort2State": {"mo_name": "BiosVfLOMPortOptionROM", "prop_name": "vp_lom_port2_state"},
        "LOMPort3State": {"mo_name": "BiosVfLOMPortOptionROM", "prop_name": "vp_lom_port3_state"},
        "LOMPortsAllState": {"mo_name": "BiosVfLOMPortOptionROM", "prop_name": "vp_lom_ports_all_state"},
        "LegacyUSBSupport": {"mo_name": "BiosVfLegacyUSBSupport", "prop_name": "vp_legacy_usb_support"},
        "LvDDRMode": {"mo_name": "BiosVfLvDIMMSupport", "prop_name": "vp_lv_ddr_mode"},
        "MMCFGBase": {"mo_name": "BiosVfMMCFGBase", "prop_name": "vp_mmcfg_base"},
        "ChannelInterLeave": {"mo_name": "BiosVfMemoryInterleave", "prop_name": "vp_channel_inter_leave"},
        "MemoryInterLeave": {"mo_name": "BiosVfMemoryInterleave", "prop_name": "vp_memory_inter_leave"},
        "RankInterLeave": {"mo_name": "BiosVfMemoryInterleave", "prop_name": "vp_rank_inter_leave"},
        "MemoryMappedIOAbove4GB": {"mo_name": "BiosVfMemoryMappedIOAbove4GB", "prop_name": "vp_memory_mapped_io_above4_gb"},
        "MirroringMode": {"mo_name": "BiosVfMirroringMode", "prop_name": "vp_mirroring_mode"},
        "NUMAOptimized": {"mo_name": "BiosVfNUMAOptimized", "prop_name": "vp_numa_optimized"},
        "OSBootWatchdogTimer": {"mo_name": "BiosVfOSBootWatchdogTimer", "prop_name": "vp_os_boot_watchdog_timer"},
        "OSBootWatchdogTimerPolicy": {"mo_name": "BiosVfOSBootWatchdogTimerPolicy", "prop_name": "vp_os_boot_watchdog_timer_policy"},
        "OSBootWatchdogTimerTimeout": {"mo_name": "BiosVfOSBootWatchdogTimerTimeout", "prop_name": "vp_os_boot_watchdog_timer_timeout"},
        "Onboard10GbitLOM": {"mo_name": "BiosVfOnboardNIC", "prop_name": "vp_onboard10_gbit_lom"},
        "OnboardGbitLOM": {"mo_name": "BiosVfOnboardNIC", "prop_name": "vp_onboard_gbit_lom"},
        "OnboardSCUStorageSupport": {"mo_name": "BiosVfOnboardStorage", "prop_name": "vp_onboard_scu_storage_support"},
        "OnboardSCUStorageSWStack": {"mo_name": "BiosVfOnboardStorageSWStack", "prop_name": "vp_onboard_scu_storage_sw_stack"},
        "OutOfBandMgmtPort": {"mo_name": "BiosVfOutOfBandMgmtPort", "prop_name": "vp_out_of_band_mgmt_port"},
        "PCIOptionROMs": {"mo_name": "BiosVfPCIOptionROMs", "prop_name": "vp_pci_option_ro_ms"},
        "Slot10LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot10_link_speed"},
        "Slot10State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot10_state"},
        "Slot11LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot11_link_speed"},
        "Slot11State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot11_state"},
        "Slot12LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot12_link_speed"},
        "Slot12State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot12_state"},
        "Slot1LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot1_link_speed"},
        "Slot1State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot1_state"},
        "Slot2LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot2_link_speed"},
        "Slot2State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot2_state"},
        "Slot3LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot3_link_speed"},
        "Slot3State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot3_state"},
        "Slot4LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot4_link_speed"},
        "Slot4State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot4_state"},
        "Slot5LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot5_link_speed"},
        "Slot5State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot5_state"},
        "Slot6LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot6_link_speed"},
        "Slot6State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot6_state"},
        "Slot7LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot7_link_speed"},
        "Slot7State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot7_state"},
        "Slot8LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot8_link_speed"},
        "Slot8State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot8_state"},
        "Slot9LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot9_link_speed"},
        "Slot9State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot9_state"},
        "SlotFLOMLinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_flom_link_speed"},
        "SlotFrontNvme1LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_front_nvme1_link_speed"},
        "SlotFrontNvme2LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_front_nvme2_link_speed"},
        "SlotFrontSlot5LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_front_slot5_link_speed"},
        "SlotFrontSlot6LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_front_slot6_link_speed"},
        "SlotHBALinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_hba_link_speed"},
        "SlotHBAState": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_hba_state"},
        "SlotMLOMLinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_mlom_link_speed"},
        "SlotMLOMState": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_mlom_state"},
        "SlotMRAIDLinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_mraid_link_speed"},
        "SlotMRAIDState": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_mraid_state"},
        "SlotMezzState": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_mezz_state"},
        "SlotN1State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_n1_state"},
        "SlotN2State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_n2_state"},
        "SlotRAIDLinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_raid_link_speed"},
        "SlotRAIDState": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_raid_state"},
        "SlotRearNvme1LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_rear_nvme1_link_speed"},
        "SlotRearNvme1State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_rear_nvme1_state"},
        "SlotRearNvme2LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_rear_nvme2_link_speed"},
        "SlotRearNvme2State": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_rear_nvme2_state"},
        "SlotRiser1LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_riser1_link_speed"},
        "SlotRiser1Slot1LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_riser1_slot1_link_speed"},
        "SlotRiser1Slot2LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_riser1_slot2_link_speed"},
        "SlotRiser1Slot3LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_riser1_slot3_link_speed"},
        "SlotRiser2LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_riser2_link_speed"},
        "SlotRiser2Slot4LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_riser2_slot4_link_speed"},
        "SlotRiser2Slot5LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_riser2_slot5_link_speed"},
        "SlotRiser2Slot6LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_riser2_slot6_link_speed"},
        "SlotSASState": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_sas_state"},
        "SlotSSDSlot1LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_ssd_slot1_link_speed"},
        "SlotSSDSlot2LinkSpeed": {"mo_name": "BiosVfPCISlotOptionROMEnable", "prop_name": "vp_slot_ssd_slot2_link_speed"},
        "PCIeSSDHotPlugSupport": {"mo_name": "BiosVfPCIeSSDHotPlugSupport", "prop_name": "vp_pc_ie_ssd_hot_plug_support"},
        "POSTErrorPause": {"mo_name": "BiosVfPOSTErrorPause", "prop_name": "vp_post_error_pause"},
        "PSata": {"mo_name": "BiosVfPSata", "prop_name": "vp_p_sata"},
        "PStateCoordType": {"mo_name": "BiosVfPStateCoordType", "prop_name": "vp_p_state_coord_type"},
        "PackageCStateLimit": {"mo_name": "BiosVfPackageCStateLimit", "prop_name": "vp_package_c_state_limit"},
        "PatrolScrub": {"mo_name": "BiosVfPatrolScrub", "prop_name": "vp_patrol_scrub"},
        "PatrolScrubDuration": {"mo_name": "BiosVfPatrolScrubDuration", "prop_name": "vp_patrol_scrub_duration"},
        "PchUsb30Mode": {"mo_name": "BiosVfPchUsb30Mode", "prop_name": "vp_pch_usb30_mode"},
        "PciRomClp": {"mo_name": "BiosVfPciRomClp", "prop_name": "vp_pci_rom_clp"},
        "POPSupport": {"mo_name": "BiosVfPowerOnPasswordSupport", "prop_name": "vp_pop_support"},
        "ProcessorC1E": {"mo_name": "BiosVfProcessorC1E", "prop_name": "vp_processor_c1_e"},
        "ProcessorC3Report": {"mo_name": "BiosVfProcessorC3Report", "prop_name": "vp_processor_c3_report"},
        "ProcessorC6Report": {"mo_name": "BiosVfProcessorC6Report", "prop_name": "vp_processor_c6_report"},
        "ProcessorCState": {"mo_name": "BiosVfProcessorCState", "prop_name": "vp_processor_c_state"},
        "PwrPerfTuning": {"mo_name": "BiosVfPwrPerfTuning", "prop_name": "vp_pwr_perf_tuning"},
        "QPILinkFrequency": {"mo_name": "BiosVfQPIConfig", "prop_name": "vp_qpi_link_frequency"},
        "QpiSnoopMode": {"mo_name": "BiosVfQpiSnoopMode", "prop_name": "vp_qpi_snoop_mode"},
        "ResumeOnACPowerLoss": {"mo_name": "BiosVfResumeOnACPowerLoss", "prop_name": "vp_resume_on_ac_power_loss"},
        "SataModeSelect": {"mo_name": "BiosVfSataModeSelect", "prop_name": "vp_sata_mode_select"},
        "SelectMemoryRASConfiguration": {"mo_name": "BiosVfSelectMemoryRASConfiguration", "prop_name": "vp_select_memory_ras_configuration"},
        "SerialPortAEnable": {"mo_name": "BiosVfSerialPortAEnable", "prop_name": "vp_serial_port_a_enable"},
        "SinglePCTLEnable": {"mo_name": "BiosVfSinglePCTLEnable", "prop_name": "vp_single_pctl_enable"},
        "SparingMode": {"mo_name": "BiosVfSparingMode", "prop_name": "vp_sparing_mode"},
        "SrIov": {"mo_name": "BiosVfSrIov", "prop_name": "vp_sr_iov"},
        "SNC": {"mo_name": "BiosVfSubNumaClustering", "prop_name": "vp_snc"},
        "TPMControl": {"mo_name": "BiosVfTPMControl", "prop_name": "vp_tpm_control"},
        "TPMSupport": {"mo_name": "BiosVfTPMSupport", "prop_name": "vp_tpm_support"},
        "UCSMBootOrderRule": {"mo_name": "BiosVfUCSMBootOrderRuleControl", "prop_name": "vp_ucsm_boot_order_rule"},
        "MakeDeviceNonBootable": {"mo_name": "BiosVfUSBBootConfig", "prop_name": "vp_make_device_non_bootable"},
        "USBEmul6064": {"mo_name": "BiosVfUSBEmulation", "prop_name": "vp_usb_emul6064"},
        "AllUsbDevices": {"mo_name": "BiosVfUSBPortsConfig", "prop_name": "vp_all_usb_devices"},
        "UsbPortFront": {"mo_name": "BiosVfUSBPortsConfig", "prop_name": "vp_usb_port_front"},
        "UsbPortInternal": {"mo_name": "BiosVfUSBPortsConfig", "prop_name": "vp_usb_port_internal"},
        "UsbPortKVM": {"mo_name": "BiosVfUSBPortsConfig", "prop_name": "vp_usb_port_kvm"},
        "UsbPortRear": {"mo_name": "BiosVfUSBPortsConfig", "prop_name": "vp_usb_port_rear"},
        "UsbPortSDCard": {"mo_name": "BiosVfUSBPortsConfig", "prop_name": "vp_usb_port_sd_card"},
        "UsbPortVMedia": {"mo_name": "BiosVfUSBPortsConfig", "prop_name": "vp_usb_port_v_media"},
        "UsbXhciSupport": {"mo_name": "BiosVfUsbXhciSupport", "prop_name": "vp_usb_xhci_support"},
        "VgaPriority": {"mo_name": "BiosVfVgaPriority", "prop_name": "vp_vga_priority"},
        "WorkLoadConfig": {"mo_name": "BiosVfWorkLoadConfig", "prop_name": "vp_work_load_config"},
        "XPTPrefetch": {"mo_name": "BiosVfXPTPrefetch", "prop_name": "vp_xpt_prefetch"},
    },

}
